import { IRegExpExExecArray } from './regexex';
export declare enum CapturingState {
    Undefined = 0,
    ProcessingCapturingState = 1,
    ProcessingLookBehind = 2,
    ProcessingNonCapturingState = 3,
    Capturing = 4,
    NonCapturing = 5,
    LookAheadPositive = 6,
    LookAheadNegative = 7,
    LookBehindPositive = 8,
    LookBehindNegative = 9,
    AuxiliaryNonGrouping = 10,
    AuxiliaryNonCapturing = 11,
    SyntaxError = 12
}
export declare class SyntaxTree {
    rootExpression: string;
    start: number;
    length: number;
    capturingState: CapturingState;
    children: SyntaxTree[];
    enumerationCounter: number;
    enumerationCounterOffset: number;
    constructor(rootExpression: string, start?: number, length?: number, capturingState?: CapturingState);
    processExecResult(extendedExecReturnValue: IRegExpExExecArray, enumCounter?: number, index?: number): {
        enumCounter: number;
        index: number;
    };
    outerStart(): number;
    getGroupPrefix(): string;
    complete(): void;
    generateExpression(groupTogether?: boolean): string;
    private outerLength;
    private findGroup;
}
